clc; 
clear;
close all

load('P0Variables')

%% Select relevant feedback loops using gains in Simulink:
case1 = 1; 
z1feed = Pnom;
z2feed = q2nom;
z3feed = q3nom;
z4feed = q4nom;

%% Open loop response, no steps or disturbances
z1st   = 0;
z2st   = 0;
z3st   = 0;
z4st   = 0;
z1dist = -0.05;
z2dist = 0;
z3dist = 0;
z4dist = 0;
P1dist = 0;
P2dist = 0;
P3dist = 0;
P4dist = 0;

sim('P0PressureFlowODESim')

qnomplot = t.^(0)*2.2;
q2plot   = q2stepplot;
q3plot   = q3stepplot;
q4plot   = q4stepplot;

save(fullfile(savdir,'P0101CL'));

%% Plot pressures and and flows
%pressures
plotname = 'Open loop response';
number   = 1;
save('P0Workspace');
P0Plot();

%% Simulate step in z1, all loops open

z1st   = 0;
z2st   = 0;
z3st   = 0;
z4st   = 0;
z1dist = z1nom*0.1;
z2dist = 0;
z3dist = 0;
z4dist = 0;
P1dist = 0;
P2dist = 0;
P3dist = 0;
P4dist = 0;


sim('P0PressureFlowODESim')

qnomplot = t.^(0)*2.2;
q2plot   = q2stepplot;
q3plot   = q3stepplot;
q4plot   = q4stepplot;

save(fullfile(savdir,'P0102CL'));

%% Plot pressures and and flows
%pressures
plotname = 'Open loop response, +10% Step in z_1';
number   = 2;
save('P0Workspace');
P0Plot();

%% %% Simulate step in z2, all loops open

z1st   = 0;
z2st   = 0;
z3st   = 0;
z4st   = 0;
z1dist = 0;
z2dist = z2nom*0.1;
z3dist = 0;
z4dist = 0;
P1dist = 0;
P2dist = 0;
P3dist = 0;
P4dist = 0;


sim('P0PressureFlowODESim')

qnomplot = t.^(0)*2.2;
q2plot   = q2stepplot;
q3plot   = q3stepplot;
q4plot   = q4stepplot;

save(fullfile(savdir,'P0103CL'));
%% Plot pressures and and flows
%pressures
plotname = 'Open loop response, +10% Step in z_2';
number   = 3;
save('P0Workspace');
P0Plot();

%% Simulate step in z3, all loops open

z1st   = 0;
z2st   = 0;
z3st   = 0;
z4st   = 0;
z1dist = 0;
z2dist = 0;
z3dist = z3nom*0.1;
z4dist = 0;
P1dist = 0;
P2dist = 0;
P3dist = 0;
P4dist = 0;

sim('P0PressureFlowODESim')

qnomplot = t.^(0)*2.2;
q2plot   = q2stepplot;
q3plot   = q3stepplot;
q4plot   = q4stepplot;

save(fullfile(savdir,'P0104CL'));
%% Plot pressures and and flows
%pressure
plotname = 'Open loop response, +10% Step in z_3';
number   = 4;
save('P0Workspace');
P0Plot();

%% Simulate step in z4, all loops open

z1st   = 0;
z2st   = 0;
z3st   = 0;
z4st   = 0;
z1dist = 0;
z2dist = 0;
z3dist = 0;
z4dist = z4nom*0.1;
P1dist = 0;
P2dist = 0;
P3dist = 0;
P4dist = 0;

sim('P0PressureFlowODESim')

qnomplot = t.^(0)*2.2;
q2plot   = q2stepplot;
q3plot   = q3stepplot;
q4plot   = q4stepplot;

save(fullfile(savdir,'P0104CL'));
%% Plot pressures and and flows
%pressures
plotname = 'Open loop response, +10% Step in z_4';
number   = 5;
save('P0Workspace');
P0Plot();

 
