function plottingFunction = P0Plot()
load('P0Workspace.mat');

set(0,'DefaultTextFontName','Times',...
'DefaultTextFontSize',18,...
'DefaultAxesFontName','Times',...
'DefaultAxesFontSize',12,...
'DefaultLineLineWidth',2,...
'DefaultLineMarkerSize',7.75,...
'DefaultStairLineWidth',2)

figure(number)
y = sgtitle(plotname);
y.FontWeight = 'bold';
subplot(5,2,1)
plot(t, u(:,1), 'b')
xlabel('Time [s]')
ylabel('Opening z_1 [-]')
xlim([0 tsim])
ylim([0 1])

subplot(5,2,2)
plot(t,pstepplot,'-.b')
hold on
plot(t,P(:,1), 'r') 
hold on
%legend('P^{sp}','P')
xlabel('Time [s]')
ylabel('P [bar]')
xlim([0 tsim])
ylim([8 12])

subplot(5,2,3)
plot(t, u(:,2), 'b')
xlabel('Time [s]')
ylabel('Opening z_2 [-]')
xlim([0 tsim])
ylim([0 1])

subplot(5,2,4)
plot(t,q2plot,'-.b')
hold on
plot(t,q(:,2), 'r')
hold on
%legend('q2^{sp}','q2')
xlabel('Time [s]')
ylabel('q_2 [kmol/s]')
xlim([0 tsim])
ylim([0 1.5])

subplot(5,2,5)
plot(t, u(:,3), 'b')
hold on
xlabel('Time [s]')
ylabel('Opening z_3 [-]')
xlim([0 tsim])
ylim([0 1])

subplot(5,2,6)
plot(t,q3plot,'-.b')
hold on
plot(t,q(:,3), 'r')
hold on
%legend('q3^{sp}','q3')
xlabel('Time [s]')
ylabel('q_3 [kmol/s]')
xlim([0 tsim])
ylim([0 1.5])

subplot(5,2,7)
plot(t, u(:,4), 'b')
xlabel('Time [s]')
ylabel('Opening z_4 [-]')
xlim([0 tsim])
ylim([0 1])

subplot(5,2,8)
plot(t,q4plot,'-.b')
hold on
plot(t,q(:,4), 'r')
hold on
%legend('q3^{sp}','q3')
xlabel('Time [s]')
ylabel('q_4 [kmol/s]')
xlim([0 tsim])
ylim([0 1.5])

subplot(5,2,9)
plot(0,0,'-.b')
hold on
plot(0,0, '-.g')
hold on
plot(0,0, 'r')
axis off
legend('Nominal Value/Setpoint/Step','Maximum Value','Actual value')

subplot(5,2,10)
plot(t,qnomplot,'-.g')
hold on
plot(t,q(:,1), 'r')
hold on
%legend('q^{sp}','q')
xlabel('Time [s]')
ylabel('q [kmol/s]')
xlim([0 tsim])
ylim([0 2.2])
end
