function out = P0PressureFlowODE(x,u,d,p)
% state: P
% CVs:   P,%%%%q1,q2
% MVs:   z1,z2
P     = x(1); % state. pressure in unknown pipe, this the one we want P in.
z1    = u(1); % -, Large valve opening
z2    = u(2); % -, Small valve opening
z3    = u(3); % -,Medium valve opening
z4    = u(4); % -,Medium valve opening
P1= d(1);
P2= d(2);
P3= d(3);
P4= d(4);
%P1    = p(1); % bar, reservoir pressure
%P2    = p(2); % bar, outlet pressure
%P3    = p(3); % bar, outlet pressure
Cv1   = p(1); % Large valve coeff
Cv2   = p(2); % Small valve coeff
Cv3   = p(3); % last valve coeff
Cv4   = p(4); % last valve coeff
V     = p(5); % m3, pipe1 volume
R     = p(6); % bar*m3/mol/K, gas constant
T     = p(7); % K, temperature
q     = Cv1*z1*sqrt(P1^2-P^2); %q = q1+q2; for simplification, se main
qsaturation = max(0,min(q,2.2)); %qmin is zero, min (q,10) represents qmax
q2    = Cv2*z2*sqrt(P^2-P2^2);
q3    = Cv3*z3*sqrt(P^2-P3^2);
q4    = Cv4*z4*sqrt(P^2-P4^2);
dPdt    = R*T/V*(qsaturation-q2-q3-q4); %use qsaturation instead of q
out   = [dPdt;qsaturation;q2;q3;q4];
end