clc; 
clear;
close all

load('P0Variables')

%% Select relevant feedback loops and feeds using gains in Simulink:
case2 = 1;
z1feed = Pnom; %Only used for plotting, in reality 0.
z2feed = Pnom;
z3feed = Pnom;
z4feed = Pnom;

%% Open loop response, no steps or disturbances
z1st   = 0;                                    % Pressure SP input
z2st   = 0;                                    % q2 SP input
z3st   = 0;                                    % q3 SP input
z4st   = 0;                                    % q4 SP input
z1dist = 0;                                    % Valve one input
z2dist = 0;                                    % Valve one input
z3dist = 0;                                    % Valve one input
z4dist = 0;                                    % Valve one input
P1dist = 0;                                    % Disturbance P1 input
P2dist = 0;                                    % Disturbance P2 input
P3dist = 0;                                    % Disturbance P3 input
P4dist = 0;                                    % Disturbance P4 input

sim('P0PressureFlowODESim')                    % Run Simulink file

qnomplot = t.^(0)*2.2;                         % Prepare plotting variables
q2plot   = t.^(0)*0.5;                         % Prepare plotting variables
q3plot   = t.^(0)*0.75;                        % Prepare plotting variables
q4plot   = t.^(0)*0.75;                        % Prepare plotting variables

save(fullfile(savdir,'P1101CL'));

%% Plot pressures and and flows
%pressures
plotname = 'Open loop response';
number   = 1;
save('P0Workspace');
P0Plot();

%% %% Simulate step in z2, all loops open

z1st   = 0;                                    % Pressure SP input
z2st   = 0;                                    % q2 SP input
z3st   = 0;                                    % q3 SP input
z4st   = 0;                                    % q4 SP input
z1dist = 0;                                    % Valve one input
z2dist = z2nom*0.1;                            % Valve one input
z3dist = 0;                                    % Valve one input
z4dist = 0;                                    % Valve one input
P1dist = 0;                                    % Disturbance P1 input
P2dist = 0;                                    % Disturbance P2 input
P3dist = 0;                                    % Disturbance P3 input
P4dist = 0;                                    % Disturbance P4 input

sim('P0PressureFlowODESim')

qnomplot = t.^(0)*2.2;                         % Prepare plotting variables
q2plot   = t.^(0)*0.5;                         % Prepare plotting variables
q3plot   = t.^(0)*0.75;                        % Prepare plotting variables
q4plot   = t.^(0)*0.75;                        % Prepare plotting variables

save(fullfile(savdir,'P1103CL'));
%% Plot pressures and and flows
%pressures
plotname = 'Open loop response, +10% Step in z_2';
number   = 2;
save('P0Workspace');
P0Plot();

%% Simulate step in z3, all loops open

z1st   = 0;                                    % Pressure SP input
z2st   = 0;                                    % q2 SP input
z3st   = 0;                                    % q3 SP input
z4st   = 0;                                    % q4 SP input
z1dist = 0;                                    % Valve one input
z2dist = 0;                                    % Valve one input
z3dist = z3nom*0.1;                            % Valve one input
z4dist = 0;                                    % Valve one input
P1dist = 0;                                    % Disturbance P1 input
P2dist = 0;                                    % Disturbance P2 input
P3dist = 0;                                    % Disturbance P3 input
P4dist = 0;                                    % Disturbance P4 input

sim('P0PressureFlowODESim')

qnomplot = t.^(0)*2.2;                         % Prepare plotting variables
q2plot   = t.^(0)*0.5;                         % Prepare plotting variables
q3plot   = t.^(0)*0.75;                        % Prepare plotting variables
q4plot   = t.^(0)*0.75;                        % Prepare plotting variables

save(fullfile(savdir,'P1104CL'));
%% Plot pressures and and flows
%pressure
plotname = 'Open loop response, +10% Step in z_3';
number   = 3;
save('P0Workspace');
P0Plot();

%% Simulate step in z4, all loops open

z1st   = 0;                                    % Pressure SP input
z2st   = 0;                                    % q2 SP input
z3st   = 0;                                    % q3 SP input
z4st   = 0;                                    % q4 SP input
z1dist = 0;                                    % Valve one input
z2dist = 0;                                    % Valve one input
z3dist = 0;                                    % Valve one input
z4dist = z4nom*0.1;                            % Valve one input
P1dist = 0;                                    % Disturbance P1 input
P2dist = 0;                                    % Disturbance P2 input
P3dist = 0;                                    % Disturbance P3 input
P4dist = 0;                                    % Disturbance P4 input
sim('P0PressureFlowODESim')

qnomplot = t.^(0)*2.2;                         % Prepare plotting variables
q2plot   = t.^(0)*0.5;                         % Prepare plotting variables
q3plot   = t.^(0)*0.75;                        % Prepare plotting variables
q4plot   = t.^(0)*0.75;                        % Prepare plotting variables

save(fullfile(savdir,'P1104CL'));
%% Plot pressures and and flows
%pressures
plotname = 'Open loop response, +10% Step in z_4';
number   = 4;
save('P0Workspace');
P0Plot();

