clc; 
clear;
close all

load('P0Variables')

%% Select relevant feedback loops and feeds using gains in Simulink:
case2 = 1;
z1feed = Pnom; %Only used for plotting, in reality 0.
z2feed = Pnom;
z3feed = Pnom-1;
z4feed = Pnom-1;

%% Tune PI controller for P control
tauC = V/((qnom*R*T)/Pnom);

k_p2     = -0.058/0.05;      %10
tau_p2   = 5000;           %57
theta_p2 = 0;            %0
tau_p_c2 = tauC;        %25    %1
tau_p_I2 = min(tau_p2,4*tau_p_c2);    %4

controller_q2_P  = 1/k_p2 * tau_p2/(theta_p2+tau_p_c2);
controller_q2_I  = controller_q2_P/tau_p_I2;

k_p3     = -0.201/0.05;      
tau_p3   = 12500;           
theta_p3 = 0;          
tau_p_c3 = tauC;        
tau_p_I3 = min(tau_p3,4*tau_p_c3);   

controller_q3_P  = 1/k_p3 * tau_p3/(theta_p3+tau_p_c3);

k_p4     = -0.122/0.05;      
tau_p4   = 7500;           
theta_p4 = 0;           
tau_p_c4 = tauC;        
tau_p_I4 = min(tau_p4,4*tau_p_c4);   

controller_q4_P = 1/k_p4 * tau_p4/(theta_p4+tau_p_c4);

%Anti Windup Parameters
Kbq2   = controller_q2_I;

%% Simulate step in z2, all loops open

z1st   = 0;                                    % Pressure SP input
z2st   = 0;                                    % q2 SP input
z3st   = 0;                                    % q3 SP input
z4st   = 0;                                    % q4 SP input
z1dist = 0;                                    % Valve one input
z2dist = 0;                                    % Valve one input
z3dist = 0;                                    % Valve one input
z4dist = 0;                                    % Valve one input
P1dist = 0;%P1;                                   % Disturbance P1 input
P2dist = 0;                                    % Disturbance P2 input
P3dist = 0;                                    % Disturbance P3 input
P4dist = 0;                                    % Disturbance P4 input

sim('P0PressureFlowODESim')

pstepplot = q2stepplot;                        % Preparing plotting
qnomplot = t.^(0)*2.2;                         % Preparing plotting
q2plot   = t.^(0)*0.5;                         % Preparing plotting
q3plot   = t.^(0)*0.75;                        % Preparing plotting
q4plot   = t.^(0)*0.75;                        % Preparing plotting

save(fullfile(savdir,'P1503CL'));

%% Plot pressures and and flows
%pressures
plotname = 'Closed loop response, +100% Disturbance from P1';
number   = 1;
save('P0Workspace');
P0Plot();

%% Simulate step in z2, all loops open

z1st   = 0;                                    % Pressure SP input
z2st   = 0;                                    % q2 SP input
z3st   = 0;                                    % q3 SP input
z4st   = 0;                                    % q4 SP input
z1dist = 0;                                    % Valve one input
z2dist = 0;                                    % Valve one input
z3dist = 0;                                    % Valve one input
z4dist = 0;                                    % Valve one input
P1dist = 0;                                    % Disturbance P1 input
P2dist = P2*2;                                   % Disturbance P2 input
P3dist = 0;                                    % Disturbance P3 input
P4dist = 0;                                    % Disturbance P4 input

sim('P0PressureFlowODESim')

pstepplot = q2stepplot;                        % Preparing plotting
qnomplot = t.^(0)*2.2;                         % Preparing plotting
q2plot   = t.^(0)*0.5;                         % Preparing plotting
q3plot   = t.^(0)*0.75;                        % Preparing plotting
q4plot   = t.^(0)*0.75;                        % Preparing plotting

save(fullfile(savdir,'P1503CL'));

%% Plot pressures and and flows
%pressures
plotname = 'Closed loop response, +200% Disturbance from P2';
number   = 2;
save('P0Workspace');
P0Plot();

%% Simulate step in z2, all loops open

z1st   = 0;                                    % Pressure SP input
z2st   = 0;                                    % q2 SP input
z3st   = 0;                                    % q3 SP input
z4st   = 0;                                    % q4 SP input
z1dist = 0;                                    % Valve one input
z2dist = 0;                                    % Valve one input
z3dist = 0;                                    % Valve one input
z4dist = 0;                                    % Valve one input
P1dist = 0;                                    % Disturbance P1 input
P2dist = 0;                                    % Disturbance P2 input
P3dist = P3*2;                                   % Disturbance P3 input
P4dist = 0;                                    % Disturbance P4 input

sim('P0PressureFlowODESim')

pstepplot = q2stepplot;                        % Preparing plotting
qnomplot = t.^(0)*2.2;                         % Preparing plotting
q2plot   = t.^(0)*0.5;                         % Preparing plotting
q3plot   = t.^(0)*0.75;                        % Preparing plotting
q4plot   = t.^(0)*0.75;                        % Preparing plotting

save(fullfile(savdir,'P1503CL'));

%% Plot pressures and and flows
%pressures
plotname = 'Closed loop response, +200% Disturbance from P3';
number   = 3;
save('P0Workspace');
P0Plot();

%% Simulate step in z2, all loops open

z1st   = 0;                                    % Pressure SP input
z2st   = 0;                                    % q2 SP input
z3st   = 0;                                    % q3 SP input
z4st   = 0;                                    % q4 SP input
z1dist = 0;                                    % Valve one input
z2dist = 0;                                    % Valve one input
z3dist = 0;                                    % Valve one input
z4dist = 0;                                    % Valve one input
P1dist = 0;                                    % Disturbance P1 input
P2dist = 0;                                    % Disturbance P2 input
P3dist = 0;                                    % Disturbance P3 input
P4dist = P4*2;                                    % Disturbance P4 input

sim('P0PressureFlowODESim')

pstepplot = q2stepplot;                        % Preparing plotting
qnomplot = t.^(0)*2.2;                         % Preparing plotting
q2plot   = t.^(0)*0.5;                         % Preparing plotting
q3plot   = t.^(0)*0.75;                        % Preparing plotting
q4plot   = t.^(0)*0.75;                        % Preparing plotting

save(fullfile(savdir,'P1503CL'));

%% Plot pressures and and flows
%pressures
plotname = 'Closed loop response, +200% Disturbance from P4';
number   = 4;
save('P0Workspace');
P0Plot();

%% Simulate step in z2, all loops open

z1st   = 0;                                    % Pressure SP input
z2st   = 0;                                    % q2 SP input
z3st   = 0;                                    % q3 SP input
z4st   = 0;                                    % q4 SP input
z1dist = 0;                                    % Valve one input
z2dist = 0;                                    % Valve one input
z3dist = 0;                                    % Valve one input
z4dist = 0;                                    % Valve one input
P1dist = -P1*0.25;                             % Disturbance P1 input
P2dist = 0;                                    % Disturbance P2 input
P3dist = 0;                                    % Disturbance P3 input
P4dist = 0;                                    % Disturbance P4 input

sim('P0PressureFlowODESim')

pstepplot = q2stepplot;                        % Preparing plotting
qnomplot = t.^(0)*2.2;                         % Preparing plotting
q2plot   = t.^(0)*0.5;                         % Preparing plotting
q3plot   = t.^(0)*0.75;                        % Preparing plotting
q4plot   = t.^(0)*0.75;                        % Preparing plotting

save(fullfile(savdir,'P1503CL'));

%% Plot pressures and and flows
%pressures
plotname = 'Closed loop response, -25% Disturbance from P1';
number   = 5;
save('P0Workspace');
P0Plot();

%% Simulate step in z2, all loops open

z1st   = 0;                                    % Pressure SP input
z2st   = 0;                                    % q2 SP input
z3st   = 0;                                    % q3 SP input
z4st   = 0;                                    % q4 SP input
z1dist = 0;                                    % Valve one input
z2dist = 0;                                    % Valve one input
z3dist = 0;                                    % Valve one input
z4dist = 0;                                    % Valve one input
P1dist = 0;                                    % Disturbance P1 input
P2dist = -P2*0.5;                              % Disturbance P2 input
P3dist = 0;                                    % Disturbance P3 input
P4dist = 0;                                    % Disturbance P4 input

sim('P0PressureFlowODESim')

pstepplot = q2stepplot;                        % Preparing plotting
qnomplot = t.^(0)*2.2;                         % Preparing plotting
q2plot   = t.^(0)*0.5;                         % Preparing plotting
q3plot   = t.^(0)*0.75;                        % Preparing plotting
q4plot   = t.^(0)*0.75;                        % Preparing plotting

save(fullfile(savdir,'P1503CL'));

%% Plot pressures and and flows
%pressures
plotname = 'Closed loop response, -50% Disturbance from P2';
number   = 6;
save('P0Workspace');
P0Plot();

%% Simulate step in z2, all loops open

z1st   = 0;                                    % Pressure SP input
z2st   = 0;                                    % q2 SP input
z3st   = 0;                                    % q3 SP input
z4st   = 0;                                    % q4 SP input
z1dist = 0;                                    % Valve one input
z2dist = 0;                                    % Valve one input
z3dist = 0;                                    % Valve one input
z4dist = 0;                                    % Valve one input
P1dist = 0;                                    % Disturbance P1 input
P2dist = 0;                                    % Disturbance P2 input
P3dist = -P3*0.5;                              % Disturbance P3 input
P4dist = 0;                                    % Disturbance P4 input

sim('P0PressureFlowODESim')

pstepplot = q2stepplot;                        % Preparing plotting
qnomplot = t.^(0)*2.2;                         % Preparing plotting
q2plot   = t.^(0)*0.5;                         % Preparing plotting
q3plot   = t.^(0)*0.75;                        % Preparing plotting
q4plot   = t.^(0)*0.75;                        % Preparing plotting

save(fullfile(savdir,'P1503CL'));

%% Plot pressures and and flows
%pressures
plotname = 'Closed loop response,  -50% Disturbance from P3';
number   = 7;
save('P0Workspace');
P0Plot();

%% Simulate step in z2, all loops open

z1st   = 0;                                    % Pressure SP input
z2st   = 0;                                    % q2 SP input
z3st   = 0;                                    % q3 SP input
z4st   = 0;                                    % q4 SP input
z1dist = 0;                                    % Valve one input
z2dist = 0;                                    % Valve one input
z3dist = 0;                                    % Valve one input
z4dist = 0;                                    % Valve one input
P1dist = 0;                                    % Disturbance P1 input
P2dist = 0;                                    % Disturbance P2 input
P3dist = 0;                                    % Disturbance P3 input
P4dist = -P4*0.5;                              % Disturbance P4 input

sim('P0PressureFlowODESim')

pstepplot = q2stepplot;                        % Preparing plotting
qnomplot = t.^(0)*2.2;                         % Preparing plotting
q2plot   = t.^(0)*0.5;                         % Preparing plotting
q3plot   = t.^(0)*0.75;                        % Preparing plotting
q4plot   = t.^(0)*0.75;                        % Preparing plotting

save(fullfile(savdir,'P1503CL'));

%% Plot pressures and and flows
%pressures
plotname = 'Closed loop response, -50% Disturbance from P4';
number   = 8;
save('P0Workspace');
P0Plot();


