clc; 
clear;
close all

load('P0Variables')

%% Select relevant feedback loops and feeds using gains in Simulink:
case1 = 1;
z1feed = Pnom;
z2feed = q2nom;
z3feed = q3nom;
z4feed = q4nom;

%% Open loop response, step on z2
z1st   = 0;                                    % Pressure SP input
z2st   = 0;                                    % q2 SP input
z3st   = 0;                                    % q3 SP input
z4st   = 0;                                    % q4 SP input
z1dist = 0;                                    % Valve one input
z2dist = z2nom*0.1;                            % Valve one input
z3dist = 0;                                    % Valve one input
z4dist = 0;                                    % Valve one input
P1dist = 0;                                    % Disturbance P1 input
P2dist = 0;                                    % Disturbance P2 input
P3dist = 0;                                    % Disturbance P3 input
P4dist = 0;                                    % Disturbance P4 input

sim('P0PressureFlowODESim')                    % Run Simulink file

pstepplot = q2stepplot;                        % Preparing plotting
qnomplot = t.^(0)*2.2;                         % Preparing plotting
q2plot   = t.^(0)*0.5;                         % Preparing plotting
q3plot   = t.^(0)*0.75;                        % Preparing plotting
q4plot   = t.^(0)*0.75;                        % Preparing plotting

save(fullfile(savdir,'P1401CL'));

%% Plot pressures and and flows
%pressures
plotname = 'Open loop response, Step on z_2';
number   = 1;
save('P0Workspace');
P0Plot();

% %% Tune PI controller for P control
% tauC = V/((qnom*R*T)/Pnom);
% 
% k_p2     = -0.135/0.05;      %10
% tau_p2   = 12000;           %57
% theta_p2 = 0;            %0
% tau_p_c2 = tauC;        %25    %1
% tau_p_I2 = min(tau_p2,4*tau_p_c2);    %4
% 
% controller_q2_P  = 1/k_p2 * tau_p2/(theta_p2+tau_p_c2);
% controller_q2_I  = controller_q2_P/tau_p_I2;
% 
% controller_q3_P = 0; %k=1, theta(delay) = 0, tau_c = 1
% controller_q4_P = 0; %k=1, theta(delay) = 0, tau_c = 1
% 
% %Anti Windup Parameters
% Kb   = controller_q2_I;
% 
% %% %% Simulate step in P, PI controller loop closed
% 
% z1st   = 0;                                    % Pressure SP input
% z2st   = Pnom*0.1;                             % q2 SP input
% z3st   = 0;                                    % q3 SP input
% z4st   = 0;                                    % q4 SP input
% z1dist = 0;                                    % Valve one input
% z2dist = 0;                                    % Valve one input
% z3dist = 0;                                    % Valve one input
% z4dist = 0;                                    % Valve one input
% P1dist = 0;                                    % Disturbance P1 input
% P2dist = 0;                                    % Disturbance P2 input
% P3dist = 0;                                    % Disturbance P3 input
% P4dist = 0;                                    % Disturbance P4 input
% 
% sim('P0PressureFlowODESim')
% 
% pstepplot = q2stepplot;                        % Preparing plotting
% qnomplot = t.^(0)*2.2;                         % Preparing plotting
% q2plot   = t.^(0)*0.5;                         % Preparing plotting
% q3plot   = t.^(0)*0.75;                        % Preparing plotting
% q4plot   = t.^(0)*0.75;                        % Preparing plotting
% 
% save(fullfile(savdir,'P1403CL'));
% 
% %% Plot pressures and and flows
% %pressures
% plotname = 'Closed loop response, SP change in P';
% number   = 2;
% save('P0Workspace');
% P0Plot();
% 
% %% Simulate step in z2, all loops open
% 
% z1st   = 0;                                    % Pressure SP input
% z2st   = 0;                                    % q2 SP input
% z3st   = 0;                                    % q3 SP input
% z4st   = 0;                                    % q4 SP input
% z1dist = 0;                                    % Valve one input
% z2dist = 0;                                    % Valve one input
% z3dist = z3nom*0.1;                                    % Valve one input
% z4dist = 0;                                    % Valve one input
% P1dist = 0;                                    % Disturbance P1 input
% P2dist = 0;                                    % Disturbance P2 input
% P3dist = 0;                                    % Disturbance P3 input
% P4dist = 0;                                    % Disturbance P4 input
% 
% sim('P0PressureFlowODESim')
% 
% pstepplot = q2stepplot;                        % Preparing plotting
% qnomplot = t.^(0)*2.2;                         % Preparing plotting
% q2plot   = t.^(0)*0.5;                         % Preparing plotting
% q3plot   = t.^(0)*0.75;                        % Preparing plotting
% q4plot   = t.^(0)*0.75;                        % Preparing plotting
% 
% save(fullfile(savdir,'P1403CL'));
% 
% %% Plot pressures and and flows
% %pressures
% plotname = 'Open Loop Response, Step Change on z_3';
% number   = 3;
% save('P0Workspace');
% P0Plot();
% 
% %% Tune PI controller for P control
% tauC = V/((qnom*R*T)/Pnom);
% 
% k_p2     = -0.135/0.05;      %10
% tau_p2   = 12000;           %57
% theta_p2 = 0;            %0
% tau_p_c2 = tauC;        %25    %1
% tau_p_I2 = min(tau_p2,4*tau_p_c2);    %4
% 
% controller_q2_P  = 1/k_p2 * tau_p2/(theta_p2+tau_p_c2);
% controller_q2_I  = controller_q2_P/tau_p_I2;
% 
% k_p3     = -0.094/0.05;      %10
% tau_p3   = 4000;           %57
% theta_p3 = 0;            %0
% tau_p_c3 = tauC;        %25    %1
% tau_p_I3 = min(tau_p3,4*tau_p_c3);    %4
% 
% controller_q3_P  = 1/k_p3 * tau_p3/(theta_p3+tau_p_c3);
% controller_q3_I  = controller_q3_P/tau_p_I3;
% 
% k_p4     = 0;      %10
% tau_p4   = 0;           %57
% theta_p4 = 0;            %0
% tau_p_c4 = 0;        %25    %1
% tau_p_I4 = 0;    %4
% 
% controller_q4_P  = 0;
% controller_q4_I  = 0;
% 
% %Anti Windup Parameters
% Kbq2   = controller_q2_I;
% Kbq3   = controller_q3_I;
% Kbq4   = controller_q4_I;
% 
% %% %% Simulate step in z2, all loops open
% 
% z1st   = 0;                                    % Pressure SP input
% z2st   = 0;                                    % q2 SP input
% z3st   = Pnom*0.1;                             % q3 SP input
% z4st   = 0;                                    % q4 SP input
% z1dist = 0;                                    % Valve one input
% z2dist = 0;                                    % Valve one input
% z3dist = 0;                                    % Valve one input
% z4dist = 0;                                    % Valve one input
% P1dist = 0;                                    % Disturbance P1 input
% P2dist = 0;                                    % Disturbance P2 input
% P3dist = 0;                                    % Disturbance P3 input
% P4dist = 0;                                    % Disturbance P4 input
% 
% sim('P0PressureFlowODESim')
% 
% pstepplot = q3stepplot;                        % Preparing plotting
% qnomplot = t.^(0)*2.2;                         % Preparing plotting
% q2plot   = t.^(0)*0.5;                         % Preparing plotting
% q3plot   = t.^(0)*0.75;                        % Preparing plotting
% q4plot   = t.^(0)*0.75;                        % Preparing plotting
% 
% save(fullfile(savdir,'P1403CL'));
% 
% %% Plot pressures and and flows
% %pressures
% plotname = 'Closed loop response, SP change in P';
% number   = 4;
% save('P0Workspace');
% P0Plot();
% 
% %% Simulate step in z2, all loops open
% 
% z1st   = 0;                                    % Pressure SP input
% z2st   = 0;                                    % q2 SP input
% z3st   = 0;                                    % q3 SP input
% z4st   = 0;                                    % q4 SP input
% z1dist = 0;                                    % Valve one input
% z2dist = 0;                                    % Valve one input
% z3dist = 0;                                    % Valve one input
% z4dist = z4nom*0.1;                                    % Valve one input
% P1dist = 0;                                    % Disturbance P1 input
% P2dist = 0;                                    % Disturbance P2 input
% P3dist = 0;                                    % Disturbance P3 input
% P4dist = 0;                                    % Disturbance P4 input
% 
% sim('P0PressureFlowODESim')
% 
% pstepplot = q2stepplot;                        % Preparing plotting
% qnomplot = t.^(0)*2.2;                         % Preparing plotting
% q2plot   = t.^(0)*0.5;                         % Preparing plotting
% q3plot   = t.^(0)*0.75;                        % Preparing plotting
% q4plot   = t.^(0)*0.75;                        % Preparing plotting
% 
% save(fullfile(savdir,'P1403CL'));
% 
% %% Plot pressures and and flows
% %pressures
% plotname = 'Open Loop Response, Step Change on z_4';
% number   = 5;
% save('P0Workspace');
% P0Plot();
% 
% %% All controllers tuned
% tauC = V/((qnom*R*T)/Pnom);
% 
% k_p2     = -0.135/0.05;      
% tau_p2   = 12000;        
% theta_p2 = 0;         
% tau_p_c2 = tauC;      
% tau_p_I2 = min(tau_p2,4*tau_p_c2);   
% 
% controller_q2_P  = 1/k_p2 * tau_p2/(theta_p2+tau_p_c2);
% controller_q2_I  = controller_q2_P/tau_p_I2;
% 
% k_p3     = -0.094/0.05;    
% tau_p3   = 4000;         
% theta_p3 = 0;        
% tau_p_c3 = tauC;        
% tau_p_I3 = min(tau_p3,4*tau_p_c3);    
% 
% controller_q3_P  = 1/k_p3 * tau_p3/(theta_p3+tau_p_c3);
% controller_q3_I  = controller_q3_P/tau_p_I3;
% 
% k_p4     = -0.066/0.05;     
% tau_p4   = 3000;          
% theta_p4 = 0;            
% tau_p_c4 = tauC;       
% tau_p_I4 = min(tau_p4,4*tau_p_c4);   
% 
% controller_q4_P  = 1/k_p4 * tau_p4/(theta_p4+tau_p_c4);
% controller_q4_I  = controller_q4_P/tau_p_I4;
% 
% 
% %Anti Windup Parameters
% Kbq2   = controller_q2_I;
% Kbq3   = controller_q3_I;
% Kbq4   = controller_q4_I;
% 
% %% %% Simulate step in z2, all loops open
% 
% z1st   = 0;                                    % Pressure SP input
% z2st   = 0;                                    % q2 SP input
% z3st   = 0;                                    % q3 SP input
% z4st   = Pnom*0.1;                             % q4 SP input
% z1dist = 0;                                    % Valve one input
% z2dist = 0;                                    % Valve one input
% z3dist = 0;                                    % Valve one input
% z4dist = 0;                                    % Valve one input
% P1dist = 0;                                    % Disturbance P1 input
% P2dist = 0;                                    % Disturbance P2 input
% P3dist = 0;                                    % Disturbance P3 input
% P4dist = 0;                                    % Disturbance P4 input
% 
% sim('P0PressureFlowODESim')
% 
% pstepplot = q4stepplot;                        % Preparing plotting
% qnomplot = t.^(0)*2.2;                         % Preparing plotting
% q2plot   = t.^(0)*0.5;                         % Preparing plotting
% q3plot   = t.^(0)*0.75;                        % Preparing plotting
% q4plot   = t.^(0)*0.75;                        % Preparing plotting
% 
% save(fullfile(savdir,'P1403CL'));
% 
% %% Plot pressures and and flows
% %pressures
% plotname = 'Closed loop response, all controllers tuned, SP change in P';
% number   = 6;
% save('P0Workspace');
% P0Plot();
% 
% %% Simulate step in z2, all loops open
% 
% z1st   = 0;                                    % Pressure SP input
% z2st   = 0;                                    % q2 SP input
% z3st   = 0;                                    % q3 SP input
% z4st   = 0;                                    % q4 SP input
% z1dist = 0;                                    % Valve one input
% z2dist = 0;                                    % Valve one input
% z3dist = 0;                                    % Valve one input
% z4dist = 0;                                    % Valve one input
% P1dist = P1;                                   % Disturbance P1 input
% P2dist = 0;                                    % Disturbance P2 input
% P3dist = 0;                                    % Disturbance P3 input
% P4dist = 0;                                    % Disturbance P4 input
% 
% sim('P0PressureFlowODESim')
% 
% pstepplot = q2stepplot;                        % Preparing plotting
% qnomplot = t.^(0)*2.2;                         % Preparing plotting
% q2plot   = t.^(0)*0.5;                         % Preparing plotting
% q3plot   = t.^(0)*0.75;                        % Preparing plotting
% q4plot   = t.^(0)*0.75;                        % Preparing plotting
% 
% save(fullfile(savdir,'P1403CL'));
% 
% %% Plot pressures and and flows
% %pressures
% plotname = 'Closed loop response, +100% Disturbance from P1';
% number   = 7;
% save('P0Workspace');
% P0Plot();
% 
% %% Simulate step in z2, all loops open
% 
% z1st   = 0;                                    % Pressure SP input
% z2st   = 0;                                    % q2 SP input
% z3st   = 0;                                    % q3 SP input
% z4st   = 0;                                    % q4 SP input
% z1dist = 0;                                    % Valve one input
% z2dist = 0;                                    % Valve one input
% z3dist = 0;                                    % Valve one input
% z4dist = 0;                                    % Valve one input
% P1dist = 0;                                    % Disturbance P1 input
% P2dist = P2*2;                                   % Disturbance P2 input
% P3dist = 0;                                    % Disturbance P3 input
% P4dist = 0;                                    % Disturbance P4 input
% 
% sim('P0PressureFlowODESim')
% 
% pstepplot = q2stepplot;                        % Preparing plotting
% qnomplot = t.^(0)*2.2;                         % Preparing plotting
% q2plot   = t.^(0)*0.5;                         % Preparing plotting
% q3plot   = t.^(0)*0.75;                        % Preparing plotting
% q4plot   = t.^(0)*0.75;                        % Preparing plotting
% 
% save(fullfile(savdir,'P1403CL'));
% 
% %% Plot pressures and and flows
% %pressures
% plotname = 'Closed loop response, +200% Disturbance from P2';
% number   = 8;
% save('P0Workspace');
% P0Plot();
% 
% %% Simulate step in z2, all loops open
% 
% z1st   = 0;                                    % Pressure SP input
% z2st   = 0;                                    % q2 SP input
% z3st   = 0;                                    % q3 SP input
% z4st   = 0;                                    % q4 SP input
% z1dist = 0;                                    % Valve one input
% z2dist = 0;                                    % Valve one input
% z3dist = 0;                                    % Valve one input
% z4dist = 0;                                    % Valve one input
% P1dist = 0;                                    % Disturbance P1 input
% P2dist = 0;                                    % Disturbance P2 input
% P3dist = P3*2;                                   % Disturbance P3 input
% P4dist = 0;                                    % Disturbance P4 input
% 
% sim('P0PressureFlowODESim')
% 
% pstepplot = q2stepplot;                        % Preparing plotting
% qnomplot = t.^(0)*2.2;                         % Preparing plotting
% q2plot   = t.^(0)*0.5;                         % Preparing plotting
% q3plot   = t.^(0)*0.75;                        % Preparing plotting
% q4plot   = t.^(0)*0.75;                        % Preparing plotting
% 
% save(fullfile(savdir,'P1403CL'));
% 
% %% Plot pressures and and flows
% %pressures
% plotname = 'Closed loop response, +200% Disturbance from P3';
% number   = 9;
% save('P0Workspace');
% P0Plot();
% 
% %% Simulate step in z2, all loops open
% 
% z1st   = 0;                                    % Pressure SP input
% z2st   = 0;                                    % q2 SP input
% z3st   = 0;                                    % q3 SP input
% z4st   = 0;                                    % q4 SP input
% z1dist = 0;                                    % Valve one input
% z2dist = 0;                                    % Valve one input
% z3dist = 0;                                    % Valve one input
% z4dist = 0;                                    % Valve one input
% P1dist = 0;                                    % Disturbance P1 input
% P2dist = 0;                                    % Disturbance P2 input
% P3dist = 0;                                    % Disturbance P3 input
% P4dist = P4*2;                                    % Disturbance P4 input
% 
% sim('P0PressureFlowODESim')
% 
% pstepplot = q2stepplot;                        % Preparing plotting
% qnomplot = t.^(0)*2.2;                         % Preparing plotting
% q2plot   = t.^(0)*0.5;                         % Preparing plotting
% q3plot   = t.^(0)*0.75;                        % Preparing plotting
% q4plot   = t.^(0)*0.75;                        % Preparing plotting
% 
% save(fullfile(savdir,'P1403CL'));
% 
% %% Plot pressures and and flows
% %pressures
% plotname = 'Closed loop response, +200% Disturbance from P4';
% number   = 10;
% save('P0Workspace');
% P0Plot();
% 
% %% Simulate step in z2, all loops open
% 
% z1st   = 0;                                    % Pressure SP input
% z2st   = 0;                                    % q2 SP input
% z3st   = 0;                                    % q3 SP input
% z4st   = 0;                                    % q4 SP input
% z1dist = 0;                                    % Valve one input
% z2dist = 0;                                    % Valve one input
% z3dist = 0;                                    % Valve one input
% z4dist = 0;                                    % Valve one input
% P1dist = -P1*0.25;                             % Disturbance P1 input
% P2dist = 0;                                    % Disturbance P2 input
% P3dist = 0;                                    % Disturbance P3 input
% P4dist = 0;                                    % Disturbance P4 input
% 
% sim('P0PressureFlowODESim')
% 
% pstepplot = q2stepplot;                        % Preparing plotting
% qnomplot = t.^(0)*2.2;                         % Preparing plotting
% q2plot   = t.^(0)*0.5;                         % Preparing plotting
% q3plot   = t.^(0)*0.75;                        % Preparing plotting
% q4plot   = t.^(0)*0.75;                        % Preparing plotting
% 
% save(fullfile(savdir,'P1403CL'));
% 
% %% Plot pressures and and flows
% %pressures
% plotname = 'Closed loop response, -30% Disturbance from P1';
% number   = 11;
% save('P0Workspace');
% P0Plot();
% 
% %% Simulate step in z2, all loops open
% 
% z1st   = 0;                                    % Pressure SP input
% z2st   = 0;                                    % q2 SP input
% z3st   = 0;                                    % q3 SP input
% z4st   = 0;                                    % q4 SP input
% z1dist = 0;                                    % Valve one input
% z2dist = 0;                                    % Valve one input
% z3dist = 0;                                    % Valve one input
% z4dist = 0;                                    % Valve one input
% P1dist = 0;                                    % Disturbance P1 input
% P2dist = -P2*0.5;                              % Disturbance P2 input
% P3dist = 0;                                    % Disturbance P3 input
% P4dist = 0;                                    % Disturbance P4 input
% 
% sim('P0PressureFlowODESim')
% 
% pstepplot = q2stepplot;                        % Preparing plotting
% qnomplot = t.^(0)*2.2;                         % Preparing plotting
% q2plot   = t.^(0)*0.5;                         % Preparing plotting
% q3plot   = t.^(0)*0.75;                        % Preparing plotting
% q4plot   = t.^(0)*0.75;                        % Preparing plotting
% 
% save(fullfile(savdir,'P1403CL'));
% 
% %% Plot pressures and and flows
% %pressures
% plotname = 'Closed loop response, -50% Disturbance from P2';
% number   = 12;
% save('P0Workspace');
% P0Plot();
% 
% %% Simulate step in z2, all loops open
% 
% z1st   = 0;                                    % Pressure SP input
% z2st   = 0;                                    % q2 SP input
% z3st   = 0;                                    % q3 SP input
% z4st   = 0;                                    % q4 SP input
% z1dist = 0;                                    % Valve one input
% z2dist = 0;                                    % Valve one input
% z3dist = 0;                                    % Valve one input
% z4dist = 0;                                    % Valve one input
% P1dist = 0;                                    % Disturbance P1 input
% P2dist = 0;                                    % Disturbance P2 input
% P3dist = -P3*0.5;                              % Disturbance P3 input
% P4dist = 0;                                    % Disturbance P4 input
% 
% sim('P0PressureFlowODESim')
% 
% pstepplot = q2stepplot;                        % Preparing plotting
% qnomplot = t.^(0)*2.2;                         % Preparing plotting
% q2plot   = t.^(0)*0.5;                         % Preparing plotting
% q3plot   = t.^(0)*0.75;                        % Preparing plotting
% q4plot   = t.^(0)*0.75;                        % Preparing plotting
% 
% save(fullfile(savdir,'P1403CL'));
% 
% %% Plot pressures and and flows
% %pressures
% plotname = 'Closed loop response,  -50% Disturbance from P3';
% number   = 13;
% save('P0Workspace');
% P0Plot();
% 
% %% Simulate step in z2, all loops open
% 
% z1st   = 0;                                    % Pressure SP input
% z2st   = 0;                                    % q2 SP input
% z3st   = 0;                                    % q3 SP input
% z4st   = 0;                                    % q4 SP input
% z1dist = 0;                                    % Valve one input
% z2dist = 0;                                    % Valve one input
% z3dist = 0;                                    % Valve one input
% z4dist = 0;                                    % Valve one input
% P1dist = 0;                                    % Disturbance P1 input
% P2dist = 0;                                    % Disturbance P2 input
% P3dist = 0;                                    % Disturbance P3 input
% P4dist = -P4*0.5;                              % Disturbance P4 input
% 
% sim('P0PressureFlowODESim')
% 
% pstepplot = q2stepplot;                        % Preparing plotting
% qnomplot = t.^(0)*2.2;                         % Preparing plotting
% q2plot   = t.^(0)*0.5;                         % Preparing plotting
% q3plot   = t.^(0)*0.75;                        % Preparing plotting
% q4plot   = t.^(0)*0.75;                        % Preparing plotting
% 
% save(fullfile(savdir,'P1403CL'));
% 
% %% Plot pressures and and flows
% %pressures
% plotname = 'Closed loop response, -50% Disturbance from P4';
% number   = 14;
% save('P0Workspace');
% P0Plot();
% 

