clc; 
clear;
close all

load('P0Variables')

%% Select relevant feedback loops and feeds using gains in Simulink:
case2 = 1;
z1feed = Pnom;
z2feed = Pnom;
z3feed = Pnom;
z4feed = Pnom;

%% Open loop response, no steps or disturbances
z1st   = 0;                                    % Pressure SP input
z2st   = 0;                                    % q2 SP input
z3st   = 0;                                    % q3 SP input
z4st   = 0;                                    % q4 SP input
z1dist = z1nom*0.1;                            % Valve one input
z2dist = 0;                                    % Valve one input
z3dist = 0;                                    % Valve one input
z4dist = 0;                                    % Valve one input
P1dist = 0;                                    % Disturbance P1 input
P2dist = 0;                                    % Disturbance P2 input
P3dist = 0;                                    % Disturbance P3 input
P4dist = 0;                                    % Disturbance P4 input

sim('P0PressureFlowODESim')                    % Run Simulink file

qnomplot = t.^(0)*2.2;                         % Prepare plotting variables
q2plot   = q2stepplot;                         % Prepare plotting variables
q3plot   = q3stepplot;                         % Prepare plotting variables
q4plot   = q4stepplot;                         % Prepare plotting variables

save(fullfile(savdir,'P2201CL'));

%% Plot pressures and and flows
%pressures
plotname = 'Open loop response, +10% Step on z_1';
number   = 1;
save('P0Workspace');
P0Plot();

%% Tune PI controller for P control
tauC = V/((qnom*R*T)/Pnom);

k_p     = 0.51/0.05;      %10
tau_p   = 11000;           %57
theta_p = 0;            %0
tau_p_c = tauC;        %25    %1
tau_p_I = min(tau_p,4*tau_p_c);    %4

controller_P_P  = 1/k_p * tau_p/(theta_p+tau_p_c);
controller_P_I  = controller_P_P/tau_p_I;

controller_q2_P  = 0;
controller_q3_P = 0; 
controller_q4_P = 0; 
%Anti Windup Parameters

Kbq2   = controller_P_I;

%% %% Simulate step in P, PI loop closed

z1st   = Pnom*0.1;                             % Pressure SP input
z2st   = 0;                                    % q2 SP input
z3st   = 0;                                    % q3 SP input
z4st   = 0;                                    % q4 SP input
z1dist = 0;                                    % Valve one input
z2dist = 0;                                    % Valve one input
z3dist = 0;                                    % Valve one input
z4dist = 0;                                    % Valve one input
P1dist = 0;                                    % Disturbance P1 input
P2dist = 0;                                    % Disturbance P2 input
P3dist = 0;                                    % Disturbance P3 input
P4dist = 0;                                    % Disturbance P4 input

sim('P0PressureFlowODESim')

qnomplot = t.^(0)*2.2;                         % Preparing plotting
q2plot   = t.^(0)*0.5;                         % Preparing plotting
q3plot   = t.^(0)*0.75;                        % Preparing plotting
q4plot   = t.^(0)*0.75;                        % Preparing plotting

save(fullfile(savdir,'P2203CL'));

%% Plot pressures and and flows
%pressures
plotname = 'Closed loop response, SP change in P';
number   = 2;
save('P0Workspace');
P0Plot();

%% Open loop response, step on z2
z1st   = 0;                                    % Pressure SP input
z2st   = 0;                                    % q2 SP input
z3st   = 0;                                    % q3 SP input
z4st   = 0;                                    % q4 SP input
z1dist = 0;                                    % Valve one input
z2dist = z2nom*0.1;                            % Valve one input
z3dist = 0;                                    % Valve one input
z4dist = 0;                                    % Valve one input
P1dist = 0;                                    % Disturbance P1 input
P2dist = 0;                                    % Disturbance P2 input
P3dist = 0;                                    % Disturbance P3 input
P4dist = 0;                                    % Disturbance P4 input

sim('P0PressureFlowODESim')                    % Run Simulink file

qnomplot = t.^(0)*2.2;                         % Prepare plotting variables
q2plot   = q2stepplot;                         % Prepare plotting variables
q3plot   = q3stepplot;                         % Prepare plotting variables
q4plot   = q4stepplot;                         % Prepare plotting variables

save(fullfile(savdir,'P2201CL'));

%% Plot pressures and and flows
%pressures
plotname = 'Open loop response, +10% Step on z_2';
number   = 3;
save('P0Workspace');
P0Plot();

%% Tune PI controller for P control
tauC = V/((qnom*R*T)/Pnom);

k_p     = 0.51/0.05;      %10
tau_p   = 11000;           %57
theta_p = 0;            %0
tau_p_c = tauC;        %25    %1
tau_p_I = min(tau_p,4*tau_p_c);    %4

controller_P_P  = 1/k_p * tau_p/(theta_p+tau_p_c);
controller_P_I  = controller_P_P/tau_p_I;

k_p2     = -0.063/0.05;      %10
tau_p2   = 4500;           %57
theta_p2 = 0;            %0
tau_p_c2 = tauC;        %25    %1
tau_p_I2 = min(tau_p2,4*tau_p_c2);    %4

controller_q2_P  = 1/k_p2 * tau_p2/(theta_p2+tau_p_c2);

controller_q3_P = 0; 
controller_q4_P = 0; 
%Anti Windup Parameters

Kbq2   = controller_P_I;

%% %% Simulate step in P, PI controller loop closed

z1st   = Pnom*0.1;                             % Pressure SP input
z2st   = 0;                                    % q2 SP input
z3st   = 0;                                    % q3 SP input
z4st   = 0;                                    % q4 SP input
z1dist = 0;                                    % Valve one input
z2dist = 0;                                    % Valve one input
z3dist = 0;                                    % Valve one input
z4dist = 0;                                    % Valve one input
P1dist = 0;                                    % Disturbance P1 input
P2dist = 0;                                    % Disturbance P2 input
P3dist = 0;                                    % Disturbance P3 input
P4dist = 0;                                    % Disturbance P4 input

sim('P0PressureFlowODESim')

 
qnomplot = t.^(0)*2.2;                         % Preparing plotting
q2plot   = t.^(0)*0.5;                         % Preparing plotting
q3plot   = t.^(0)*0.75;                        % Preparing plotting
q4plot   = t.^(0)*0.75;                        % Preparing plotting

save(fullfile(savdir,'P2203CL'));

%% Plot pressures and and flows
%pressures
plotname = 'Closed loop response, SP change in P';
number   = 4;
save('P0Workspace');
P0Plot();

%% Simulate step in z2, all loops open

z1st   = 0;                                    % Pressure SP input
z2st   = 0;                                    % q2 SP input
z3st   = 0;                                    % q3 SP input
z4st   = 0;                                    % q4 SP input
z1dist = 0;                                    % Valve one input
z2dist = 0;                                    % Valve one input
z3dist = z3nom*0.1;                                    % Valve one input
z4dist = 0;                                    % Valve one input
P1dist = 0;                                    % Disturbance P1 input
P2dist = 0;                                    % Disturbance P2 input
P3dist = 0;                                    % Disturbance P3 input
P4dist = 0;                                    % Disturbance P4 input

sim('P0PressureFlowODESim')

 
qnomplot = t.^(0)*2.2;                         % Preparing plotting
q2plot   = t.^(0)*0.5;                         % Preparing plotting
q3plot   = t.^(0)*0.75;                        % Preparing plotting
q4plot   = t.^(0)*0.75;                        % Preparing plotting

save(fullfile(savdir,'P2203CL'));

%% Plot pressures and and flows
%pressures
plotname = 'Open Loop Response, Step Change on z_3';
number   = 5;
save('P0Workspace');
P0Plot();

%% Tune PI controller for P control
tauC = V/((qnom*R*T)/Pnom);

k_p     = 0.51/0.05;      %10
tau_p   = 11000;           %57
theta_p = 0;            %0
tau_p_c = tauC;        %25    %1
tau_p_I = min(tau_p,4*tau_p_c);    %4

controller_P_P  = 1/k_p * tau_p/(theta_p+tau_p_c);
controller_P_I  = controller_P_P/tau_p_I;

k_p2     = -0.063/0.05;      %10
tau_p2   = 4500;           %57
theta_p2 = 0;            %0
tau_p_c2 = tauC;        %25    %1
tau_p_I2 = min(tau_p2,4*tau_p_c2);    %4

controller_q2_P  = 1/k_p2 * tau_p2/(theta_p2+tau_p_c2);

k_p3     = -0.077/0.05;      %10
tau_p3   = 4000;           %57
theta_p3 = 0;            %0
tau_p_c3 = tauC;        %25    %1
tau_p_I3 = min(tau_p3,4*tau_p_c3);    %4

controller_q3_P  = 1/k_p3 * tau_p3/(theta_p3+tau_p_c3);

controller_q4_P = 0; 
%Anti Windup Parameters

Kbq2   = controller_P_I;

%% %% Simulate SP change for P

z1st   = Pnom*0.1;                             % Pressure SP input
z2st   = 0;                                    % q2 SP input
z3st   = 0;                                    % q3 SP input
z4st   = 0;                                    % q4 SP input
z1dist = 0;                                    % Valve one input
z2dist = 0;                                    % Valve one input
z3dist = 0;                                    % Valve one input
z4dist = 0;                                    % Valve one input
P1dist = 0;                                    % Disturbance P1 input
P2dist = 0;                                    % Disturbance P2 input
P3dist = 0;                                    % Disturbance P3 input
P4dist = 0;                                    % Disturbance P4 input

sim('P0PressureFlowODESim')

pstepplot = q3stepplot;                        % Preparing plotting
qnomplot = t.^(0)*2.2;                         % Preparing plotting
q2plot   = t.^(0)*0.5;                         % Preparing plotting
q3plot   = t.^(0)*0.75;                        % Preparing plotting
q4plot   = t.^(0)*0.75;                        % Preparing plotting

save(fullfile(savdir,'P2203CL'));

%% Plot pressures and and flows
%pressures
plotname = 'Closed loop response, SP change in P';
number   = 6;
save('P0Workspace');
P0Plot();

%% Simulate step in z4, last loop to close

z1st   = 0;                                    % Pressure SP input
z2st   = 0;                                    % q2 SP input
z3st   = 0;                                    % q3 SP input
z4st   = 0;                                    % q4 SP input
z1dist = 0;                                    % Valve one input
z2dist = 0;                                    % Valve one input
z3dist = 0;                                    % Valve one input
z4dist = z4nom*0.1;                                    % Valve one input
P1dist = 0;                                    % Disturbance P1 input
P2dist = 0;                                    % Disturbance P2 input
P3dist = 0;                                    % Disturbance P3 input
P4dist = 0;                                    % Disturbance P4 input

sim('P0PressureFlowODESim')

 
qnomplot = t.^(0)*2.2;                         % Preparing plotting
q2plot   = t.^(0)*0.5;                         % Preparing plotting
q3plot   = t.^(0)*0.75;                        % Preparing plotting
q4plot   = t.^(0)*0.75;                        % Preparing plotting

save(fullfile(savdir,'P2203CL'));

%% Plot pressures and and flows
%pressures
plotname = 'Open Loop Response, Step Change on z_4';
number   = 7;
save('P0Workspace');
P0Plot();

%% Tune PI controller for P control
tauC = V/((qnom*R*T)/Pnom);

k_p     = 0.51/0.05;      %10
tau_p   = 11000;           %57
theta_p = 0;            %0
tau_p_c = tauC;        %25    %1
tau_p_I = min(tau_p,4*tau_p_c);    %4

controller_P_P  = 1/k_p * tau_p/(theta_p+tau_p_c);
controller_P_I  = controller_P_P/tau_p_I;

k_p2     = -0.063/0.05;      %10
tau_p2   = 4500;           %57
theta_p2 = 0;            %0
tau_p_c2 = tauC;        %25    %1
tau_p_I2 = min(tau_p2,4*tau_p_c2);    %4

controller_q2_P  = 1/k_p2 * tau_p2/(theta_p2+tau_p_c2);

k_p3     = -0.077/0.05;      %10
tau_p3   = 4000;           %57
theta_p3 = 0;            %0
tau_p_c3 = tauC;        %25    %1
tau_p_I3 = min(tau_p3,4*tau_p_c3);    %4

controller_q3_P  = 1/k_p3 * tau_p3/(theta_p3+tau_p_c3);

k_p4     = -0.065/0.05;      %10
tau_p4   = 3000;           %57
theta_p4 = 0;            %0
tau_p_c4 = tauC;        %25    %1
tau_p_I4 = min(tau_p4,4*tau_p_c4);    %4

controller_q4_P  = 1/k_p4 * tau_p4/(theta_p4+tau_p_c4);
%Anti Windup Parameters

Kbq2   = controller_P_I;

%% %% Simulate step in z2, all loops open

z1st   = 0;                                    % Pressure SP input
z2st   = 0;                                    % q2 SP input
z3st   = 0;                                    % q3 SP input
z4st   = Pnom*0.1;                             % q4 SP input
z1dist = 0;                                    % Valve one input
z2dist = 0;                                    % Valve one input
z3dist = 0;                                    % Valve one input
z4dist = 0;                                    % Valve one input
P1dist = 0;                                    % Disturbance P1 input
P2dist = 0;                                    % Disturbance P2 input
P3dist = 0;                                    % Disturbance P3 input
P4dist = 0;                                    % Disturbance P4 input

sim('P0PressureFlowODESim')

pstepplot = q4stepplot;                        % Preparing plotting
qnomplot = t.^(0)*2.2;                         % Preparing plotting
q2plot   = t.^(0)*0.5;                         % Preparing plotting
q3plot   = t.^(0)*0.75;                        % Preparing plotting
q4plot   = t.^(0)*0.75;                        % Preparing plotting

save(fullfile(savdir,'P2203CL'));

%% Plot pressures and and flows
%pressures
plotname = 'Closed loop response, all controllers tuned, SP change in P';
number   = 8;
save('P0Workspace');
P0Plot();

%% Simulate step in z2, all loops open

z1st   = 0;                                    % Pressure SP input
z2st   = 0;                                    % q2 SP input
z3st   = 0;                                    % q3 SP input
z4st   = 0;                                    % q4 SP input
z1dist = 0;                                    % Valve one input
z2dist = 0;                                    % Valve one input
z3dist = 0;                                    % Valve one input
z4dist = 0;                                    % Valve one input
P1dist = P1;                                   % Disturbance P1 input
P2dist = 0;                                    % Disturbance P2 input
P3dist = 0;                                    % Disturbance P3 input
P4dist = 0;                                    % Disturbance P4 input

sim('P0PressureFlowODESim')

 
qnomplot = t.^(0)*2.2;                         % Preparing plotting
q2plot   = t.^(0)*0.5;                         % Preparing plotting
q3plot   = t.^(0)*0.75;                        % Preparing plotting
q4plot   = t.^(0)*0.75;                        % Preparing plotting

save(fullfile(savdir,'P2203CL'));

%% Plot pressures and and flows
%pressures
plotname = 'Closed loop response, +100% Disturbance from P1';
number   = 9;
save('P0Workspace');
P0Plot();

%% Simulate step in z2, all loops open

z1st   = 0;                                    % Pressure SP input
z2st   = 0;                                    % q2 SP input
z3st   = 0;                                    % q3 SP input
z4st   = 0;                                    % q4 SP input
z1dist = 0;                                    % Valve one input
z2dist = 0;                                    % Valve one input
z3dist = 0;                                    % Valve one input
z4dist = 0;                                    % Valve one input
P1dist = 0;                                    % Disturbance P1 input
P2dist = P2*2;                                   % Disturbance P2 input
P3dist = 0;                                    % Disturbance P3 input
P4dist = 0;                                    % Disturbance P4 input

sim('P0PressureFlowODESim')

 
qnomplot = t.^(0)*2.2;                         % Preparing plotting
q2plot   = t.^(0)*0.5;                         % Preparing plotting
q3plot   = t.^(0)*0.75;                        % Preparing plotting
q4plot   = t.^(0)*0.75;                        % Preparing plotting

save(fullfile(savdir,'P2203CL'));

%% Plot pressures and and flows
%pressures
plotname = 'Closed loop response, +200% Disturbance from P2';
number   = 10;
save('P0Workspace');
P0Plot();

%% Simulate step in z2, all loops open

z1st   = 0;                                    % Pressure SP input
z2st   = 0;                                    % q2 SP input
z3st   = 0;                                    % q3 SP input
z4st   = 0;                                    % q4 SP input
z1dist = 0;                                    % Valve one input
z2dist = 0;                                    % Valve one input
z3dist = 0;                                    % Valve one input
z4dist = 0;                                    % Valve one input
P1dist = 0;                                    % Disturbance P1 input
P2dist = 0;                                    % Disturbance P2 input
P3dist = P3*2;                                   % Disturbance P3 input
P4dist = 0;                                    % Disturbance P4 input

sim('P0PressureFlowODESim')

 
qnomplot = t.^(0)*2.2;                         % Preparing plotting
q2plot   = t.^(0)*0.5;                         % Preparing plotting
q3plot   = t.^(0)*0.75;                        % Preparing plotting
q4plot   = t.^(0)*0.75;                        % Preparing plotting

save(fullfile(savdir,'P2203CL'));

%% Plot pressures and and flows
%pressures
plotname = 'Closed loop response, +200% Disturbance from P3';
number   = 11;
save('P0Workspace');
P0Plot();

%% Simulate step in z2, all loops open

z1st   = 0;                                    % Pressure SP input
z2st   = 0;                                    % q2 SP input
z3st   = 0;                                    % q3 SP input
z4st   = 0;                                    % q4 SP input
z1dist = 0;                                    % Valve one input
z2dist = 0;                                    % Valve one input
z3dist = 0;                                    % Valve one input
z4dist = 0;                                    % Valve one input
P1dist = 0;                                    % Disturbance P1 input
P2dist = 0;                                    % Disturbance P2 input
P3dist = 0;                                    % Disturbance P3 input
P4dist = P4*2;                                    % Disturbance P4 input

sim('P0PressureFlowODESim')

 
qnomplot = t.^(0)*2.2;                         % Preparing plotting
q2plot   = t.^(0)*0.5;                         % Preparing plotting
q3plot   = t.^(0)*0.75;                        % Preparing plotting
q4plot   = t.^(0)*0.75;                        % Preparing plotting

save(fullfile(savdir,'P2203CL'));

%% Plot pressures and and flows
%pressures
plotname = 'Closed loop response, +200% Disturbance from P4';
number   = 12;
save('P0Workspace');
P0Plot();

%% Simulate step in z2, all loops open

z1st   = 0;                                    % Pressure SP input
z2st   = 0;                                    % q2 SP input
z3st   = 0;                                    % q3 SP input
z4st   = 0;                                    % q4 SP input
z1dist = 0;                                    % Valve one input
z2dist = 0;                                    % Valve one input
z3dist = 0;                                    % Valve one input
z4dist = 0;                                    % Valve one input
P1dist = -P1*0.25;                             % Disturbance P1 input
P2dist = 0;                                    % Disturbance P2 input
P3dist = 0;                                    % Disturbance P3 input
P4dist = 0;                                    % Disturbance P4 input

sim('P0PressureFlowODESim')

 
qnomplot = t.^(0)*2.2;                         % Preparing plotting
q2plot   = t.^(0)*0.5;                         % Preparing plotting
q3plot   = t.^(0)*0.75;                        % Preparing plotting
q4plot   = t.^(0)*0.75;                        % Preparing plotting

save(fullfile(savdir,'P2203CL'));

%% Plot pressures and and flows
%pressures
plotname = 'Closed loop response, -25% Disturbance from P1';
number   = 13;
save('P0Workspace');
P0Plot();

%% Simulate step in z2, all loops open

z1st   = 0;                                    % Pressure SP input
z2st   = 0;                                    % q2 SP input
z3st   = 0;                                    % q3 SP input
z4st   = 0;                                    % q4 SP input
z1dist = 0;                                    % Valve one input
z2dist = 0;                                    % Valve one input
z3dist = 0;                                    % Valve one input
z4dist = 0;                                    % Valve one input
P1dist = 0;                                    % Disturbance P1 input
P2dist = -P2*0.5;                              % Disturbance P2 input
P3dist = 0;                                    % Disturbance P3 input
P4dist = 0;                                    % Disturbance P4 input

sim('P0PressureFlowODESim')

 
qnomplot = t.^(0)*2.2;                         % Preparing plotting
q2plot   = t.^(0)*0.5;                         % Preparing plotting
q3plot   = t.^(0)*0.75;                        % Preparing plotting
q4plot   = t.^(0)*0.75;                        % Preparing plotting

save(fullfile(savdir,'P2203CL'));

%% Plot pressures and and flows
%pressures
plotname = 'Closed loop response, -50% Disturbance from P2';
number   = 14;
save('P0Workspace');
P0Plot();

%% Simulate step in z2, all loops open

z1st   = 0;                                    % Pressure SP input
z2st   = 0;                                    % q2 SP input
z3st   = 0;                                    % q3 SP input
z4st   = 0;                                    % q4 SP input
z1dist = 0;                                    % Valve one input
z2dist = 0;                                    % Valve one input
z3dist = 0;                                    % Valve one input
z4dist = 0;                                    % Valve one input
P1dist = 0;                                    % Disturbance P1 input
P2dist = 0;                                    % Disturbance P2 input
P3dist = -P3*0.5;                              % Disturbance P3 input
P4dist = 0;                                    % Disturbance P4 input

sim('P0PressureFlowODESim')

 
qnomplot = t.^(0)*2.2;                         % Preparing plotting
q2plot   = t.^(0)*0.5;                         % Preparing plotting
q3plot   = t.^(0)*0.75;                        % Preparing plotting
q4plot   = t.^(0)*0.75;                        % Preparing plotting

save(fullfile(savdir,'P2203CL'));

%% Plot pressures and and flows
%pressures
plotname = 'Closed loop response,  -50% Disturbance from P3';
number   = 15;
save('P0Workspace');
P0Plot();

%% Simulate step in z2, all loops open

z1st   = 0;                                    % Pressure SP input
z2st   = 0;                                    % q2 SP input
z3st   = 0;                                    % q3 SP input
z4st   = 0;                                    % q4 SP input
z1dist = 0;                                    % Valve one input
z2dist = 0;                                    % Valve one input
z3dist = 0;                                    % Valve one input
z4dist = 0;                                    % Valve one input
P1dist = 0;                                    % Disturbance P1 input
P2dist = 0;                                    % Disturbance P2 input
P3dist = 0;                                    % Disturbance P3 input
P4dist = -P4*0.5;                              % Disturbance P4 input

sim('P0PressureFlowODESim')

 
qnomplot = t.^(0)*2.2;                         % Preparing plotting
q2plot   = t.^(0)*0.5;                         % Preparing plotting
q3plot   = t.^(0)*0.75;                        % Preparing plotting
q4plot   = t.^(0)*0.75;                        % Preparing plotting

save(fullfile(savdir,'P2203CL'));

%% Plot pressures and and flows
%pressures
plotname = 'Closed loop response, -50% Disturbance from P4';
number   = 16;
save('P0Workspace');
P0Plot();

